#ifndef MEMORY_HPP
#define MEMORY_HPP

#include "objects/objects.hpp"

class memory_node {
	public:
		memory_node(){
			_node = NULL;
			_next = NULL;
			_prev = NULL;
		}

		memory_node( valueObject* node ){
			_node = node;
			_next = NULL;
			_prev = NULL;
		}


		void setNext( memory_node* next ){
			_next = next;
		}

		void setPrev( memory_node* prev ){
			_prev = prev;
		}

		valueObject* get(void){ return _node; }
		memory_node* next(void){ return _next; }
		memory_node* prev(void){ return _prev; }

	protected:
		valueObject*	_node;
		memory_node*	_next;
		memory_node*	_prev;
};

class memory{
	public:
		memory(){
			_mem = NULL;
			_size= 0;
		}

		/**
		 * AhX擾
		 */
		unsigned long getAddress( string name ){
			memory_node* pt = _mem;
			if( pt == NULL ) return -1;

			for( unsigned long n = 0; n < _size; n ++ ){
				valueObject* tmp = pt->get();

				if( tmp->getName() == name )  return n; 
				pt = pt->next();
			}
			return -1;
		}

		valueObject& getMemory( string name ){
			memory_node* pt = _mem;
			for( unsigned long n = 0; n < _size; n ++ ){
				valueObject* tmp = pt->get();
				if( tmp->getName() == name )  return (*tmp); 
				pt = pt->next();
			}
			valueObject* tmp = NULL;
			return *tmp;
		}

		valueObject* getMemoryPointer( string name ){
			memory_node* pt = _mem;
			for( unsigned long n = 0; n < _size; n ++ ){
				valueObject* tmp = pt->get();
				if( tmp->getName() == name )  return tmp; 
				pt = pt->next();
			}
			valueObject* tmp = NULL;
			return tmp;
		}

		unsigned long size(void){ return _size; }

		void add( valueObject *object ){
			//m[h
			if( _mem == NULL ){
				_mem = new memory_node( object );
				_last = _mem;
				_size = 1;
				return;
			}

			//m[hǉ
			memory_node* tmp = new memory_node( object );

			_last->setNext( tmp );
			tmp->setPrev( _last );

			_last = tmp;
			_size ++;
		}

		valueObject* at( unsigned long index ){
			valueObject* ret = NULL;
			if( index > _size ) return ret;

			memory_node* pt = _mem;
			for( unsigned long n = 0; n < index; n ++ ){
				if( pt == NULL ) break;
				memory_node* tmp = pt->next();
				pt = tmp;
			}
			if( pt != NULL ) ret = pt->get();

			return ret;
		}

		void dump(void){
			cout << endl;
			cout << "----------------" << endl;
			cout << "Dump [" << _size << "]" << endl;

			for( unsigned long n = 0; n < _size; n ++ ){
				valueObject* tmp = this->at(n);
				cout << tmp->getName() << ":";

				switch( tmp->getType() ){
					case Int:
						cout << ((intObject*)tmp)->get() << endl;
						break;

					case String:
						cout << ((stringObject*)tmp)->get() << endl;
						break;
				}
			}

			cout << "----------------" << endl;
		}

	protected:
		memory_node*	_mem;
		memory_node*	_last;
		unsigned long	_size;

	private:
};


#endif
