#ifndef INTOBJECT_HPP
#define INTOBJECT_HPP

#include "valueObject.hpp"

class intObject : public valueObject{
	public:
		intObject(unsigned long address, std::string name ) : valueObject( address, name ){
			_type = Int;
		}

		long get(void){
			return _value;
		}

		long set(long value){
			_value = value;
			return _value;
		}

		intObject& operator=( intObject value ){
			_value = value.get();
			return *this;
		}

		intObject& operator=( long value ){
			_value = value;
			return *this;
		}

		long operator+( long value ){
			return _value + value;
		}
		
		long operator+( intObject value ){
			return _value + value.get();
		}

		intObject& operator+=( long value ){
			_value += value;
			return *this;
		}

		intObject& operator+=( intObject* value ){
			_value += value->get();
			return *this;
		}

		long operator+=( intObject value ){
			_value += value.get();
			return _value;
		}

		long operator-( long value ){
			return _value - value;
		}

		long operator-( intObject value ){
			return _value - value.get();
		}

		long operator*( long value ){
			return _value * value;
		}

		long operator*( intObject value ){
			return _value * value.get();
		}

		long operator*=( long value ){
			_value *= value;
			return _value;
		}

		long operator*=( intObject value ){
			_value *= value.get();
			return _value;
		}
		
		long operator/( long value ){
			return _value / value;
		}

		long operator/( intObject value ){
			return _value / value.get();
		}

		long operator/=( long value ){
			_value /= value;
			return _value;
		}

		long operator/=( intObject value ){
			_value /= value.get();
			return _value;
		}

		long operator%( long value ){
			return _value % value;
		}

		long operator%( intObject value ){
			return _value % value.get();
		}

	protected:
		long _value;
			
};
#endif
