#ifndef STRINGOBJECT_HPP
#define STRINGOBJECT_HPP

#include "valueObject.hpp"

class stringObject : public valueObject{
	public:
		stringObject(unsigned long address, std::string name ) : valueObject( address, name ) {
			_type = String;
		}

		std::string get(void){
			return _value;
		}

		std::string set(std::string value){
			_value = value;
			return _value;
		}

		stringObject& operator=( std::string value ){
			_value = value;
			return *this;
		}

		std::string operator+( std::string value ){
			return _value + value;
		}
		
		std::string operator+( stringObject value ){
			return _value + value.get();
		}

		stringObject& operator+=( std::string value ){
			_value += value;
			return *this;
		}

		stringObject& operator+=( stringObject value ){
			_value += value.get();
			return *this;
		}

		stringObject& operator+=( stringObject* value ){
			_value += value->get();
			return *this;
		}

	protected:
		std::string _value;
			
};
#endif
