#ifndef SCRIPTER_HPP
#define SCRIPTER_HPP

#include <vector>
#include <iostream>
#include <fstream>
#include <sstream>
#include <string.h>

using namespace std;

#include "objects/objects.hpp"
#include "commandList.hpp"
#include "memory.hpp"


#define TARKEN_NUM	1
#define TARKEN_STR	2
#define TARKEN_RES	3

class scripter {
	public:
		scripter(){
			//_source = NULL;
			_memory = new memory();
		}

		/**
		 * t@CXNvgǂݏo
		 */
		bool loadFile( string filename ){
			ifstream ifs;
			const char *name = filename.c_str();
			ifs.open( name, ios::in );
			if( !ifs ) return false;

			ifs.seekg( 0, ios::end );

			int size = ifs.tellg();
			ifs.seekg( 0, ios::beg );
			char *buf = new char[size];

			ifs.read( buf, size );
			ifs.close();

			string tmp = buf;
			delete( buf );

			return loadString( tmp );
		}

		/**
		 * 񂩂XNvgǂݏo
		 */
		bool loadString( string source ){
			_source = split( source, "\n" );

			init();
			return true;
		}

		/**
		 *XNvgs
		 */
		void run(){
			cout << "source lines : " << _source.size() << endl << endl;
			for( int n = 0; n < _source.size(); n ++ ){
				if( _debug ) cout << n << " : ";

				runStep();

				if( _debug ) cout << endl;
			}
			cout << endl;
		}

		/**
		 * 1steps
		 */
		void runStep(){
			_line ++;

			string cmd = trim( _source.at( _line ) );
			if( cmd.length() == 0 ) return;

			vector<string> tarken = getTarken( cmd );

			//tarken Dump
			if( _debug ) {
				for( int na = 0; na < tarken.size(); na ++ ){
					cout << tarken.at(na) << " ";
				}
			}

			//߂Ȃ
			if( tarken.size() == 0 ) {
				if( _debug ) { cout << cmd ; }
				return;
			}

			if( _debug ) {
				cout << endl;
			}


			int method = _commandList.getCommand( tarken.at(0) );
			//cout << "method " << method << endl;
			unsigned long mem = 0;
			switch( method ){
				case METHOD_SET:
					if( tarken.at(2) != "=" ) {
						cout << "error " << endl;
						exit(0);
					}
					method_set( tarken );
					break;

				case METHOD_ADD:
					method_add( tarken );
					break;

				case SYSTEM_DUMP:
					_memory->dump();
					break;

				case SYSTEM_DBUG:
					_debug = getBool( tarken.at(1) );
					break;
			}

		}

	protected:
		vector<string>		_source;
		memory				*_memory;
		commandList			_commandList;
		long				_line;
		bool				_debug;

		void init(void){
			_line = -1;
			_debug = false;
		}

		int method_set( vector<string>& tarken ){
			unsigned long mem = _memory->getAddress( tarken.at(1) );
			if(  mem == -1 ){
				//VKǉ
				int type = getTarkenType( tarken.at(3) );
				int addr = _memory->size();
				string name = tarken.at(1);
				//cout << "type : " << type << endl;
				switch( type ){
					case TARKEN_NUM:
						{
							intObject *val = new intObject( addr, name );
							*val =  getInt( tarken.at(3) );

							_memory->add( (valueObject*)val );
						}
						break;

					case TARKEN_STR:
						{
							stringObject *val = new stringObject( addr, name );
							*val = getStr( tarken.at(3) );

							_memory->add( (valueObject*)val );
						}
						break;

					default:
						//g\bh
						break;
				}
			} else {
				//ւ̃ANZX
			}
		}

		int method_add( vector<string>& tarken ){
			unsigned long mem = _memory->getAddress( tarken.at(1) );
			if( mem == -1 ){
				//`ϐ̏ꍇ@Vɕϐ蓖Ă
				int addr = _memory->size();
				int type = getTarkenType( tarken.at(2) );
				switch( type ){
					case TARKEN_NUM:
						{
							intObject *val = new intObject( addr, tarken.at(1) );
							*val =  getInt( tarken.at(2) );

							_memory->add( (valueObject*)val );
						}
						return 0;

					case TARKEN_STR:
						{
							stringObject *val = new stringObject( addr, tarken.at(1) );
							*val = getStr( tarken.at(2) );

							_memory->add( (valueObject*)val );
						}
						return 0;

					default:
						//g\bh
						break;
				}

				//G[
				cout << "don't hav name : " << tarken.at(1) << endl ;
				_memory->dump();
				exit(0);
			}

			int type = getTarkenType( tarken.at(2) );
			//cout << "value type: " << type << endl;

			valueObject* obj = _memory->getMemoryPointer( tarken.at(1) );
			switch( type ){
				case TARKEN_NUM:
					*(intObject*)obj += getInt( tarken.at(2) );
					break;

				case TARKEN_STR:
					//cout << "Add tarken : " << tarken.at(2) << endl;
					//cout << "Add String : " << getStr( tarken.at(2) ) << endl;
					*(stringObject*)obj += getStr( tarken.at(2) );
					break;

				case TARKEN_RES:
					mem = _memory->getAddress( tarken.at(2) );
					if( mem != -1 ){
						//ϐ
						valueObject* tmp =
							_memory->getMemoryPointer( tarken.at(2) );
						switch( obj->getType() ){
							case Int:
								if( tmp->getType() != Int ) break;
								*((intObject*)obj) +=( (intObject*)tmp );
								break;

							case String:
								if( tmp->getType() != String ) break;
								*((stringObject*)obj) +=( (stringObject*)tmp );
								break;
						}
					} else {
						//\[X
					}
					break;
			}
			return 0;
		}

	private:
		/**
		 * delimŕ𕪊
		 */
		vector<string> split(const string &str, const string &delim){
			vector<string> res;

			size_t current = 0, found, delimlen = delim.size();
			while((found = str.find(delim, current)) != string::npos){
				res.push_back(string(str, current, found - current));
				current = found + delimlen;
			}
			res.push_back(string(str, current, str.size() - current));
			return res;
		}

		/**
		 * sAs̗]ȕ폜
		 */
		string trim( const string& str ) {
			int nCnt;
			char* lpcWk = (char*)str.c_str();
			int nLen = strlen(lpcWk);
			int nStart = 0;
			int nEnd = nLen - 1;

			if( nEnd == 0 ) return "";

			// Jn`FbN
			for( nCnt = 0; nCnt < nLen; nCnt ++ ){
				if( lpcWk[nCnt] != ' ' ){
					nStart = nCnt;
					break;
				}
			}

			// I`FbN
			for( nCnt = nLen - 1; nCnt >= 0; nCnt -- ){
				if( lpcWk[nCnt] != ' ' ){
					nEnd = nCnt;
					break;
				}
			}

			// ԋp
			return(str.substr( nStart, nEnd - nStart + 1 ));
		}

		/**
		 * tarkenɕʂ
		 */
		vector<string> getTarken(const string &str ){
			vector<string> res;

			char delim[] = { ' ', '\t', '\n', '\r', '"', '\'', '\0' };
			char strChar[]={ '"', '\'', '\0' };

			const char *src = str.c_str();
			int len = strlen( src );
			string *tmp = new string();
			bool	stringFlag = false;

			//Rg
			if( src[0] == '#' ){
				return res;
			}

			for( int n = 0; n < len; n ++ ){
				//񏈗
				if( stringFlag ){
					if( existsChar( src[n], strChar ) ){
						stringFlag = false;
						(*tmp) += src[n];
						res.push_back( *tmp );
						tmp = new string();
						continue;
					}

					(*tmp) += src[n];
					continue;
				}

				//g[N
				if( existsChar( src[n], delim ) ){
					if( existsChar( src[n], strChar ) ){
						stringFlag = true;
						(*tmp) += src[n];
						continue;
					} else {
						res.push_back( *tmp );
						tmp = new string();
						continue;
					}
				}
				(*tmp) += src[n];
			}

			return res;
		}

		/**
		 * src̕ listɊ܂܂Ă邩𒲂ׂ
		 */
		bool existsChar( const char src, const char *list ){
			int len = strlen( list );
			for( int n = 0; n < len; n ++ ){
				if( src == list[n] ) return true;
			}

			return false;
		}

		/**
		 * val ^𔻕ʂ
		 */
		int getTarkenType( const string val ){
			int tmp;
			stringstream ss;

			ss << val;
			ss >> tmp;

			ss.clear();
			ss.str("");
			ss << tmp;

			//l^
			if( val == ss.str() ) return TARKEN_NUM;

			//
			const char *str = val.c_str();
			int len = val.length() -1;
			if( str[0] == '"' && str[len] == '"' ) return TARKEN_STR;

			return TARKEN_RES;
		}

		/**
		 * int^ɕϊ
		 */
		int getInt( string val ){
			int tmp;
			stringstream ss;

			ss << val;
			ss >> tmp;

			ss.clear();
			
			return tmp;
		}

		/**
		 * 擾
		 */
		string getStr( string val ){
			int len = val.length();
			return val.substr( 1, len - 2 );
		}

		/**
		 * bool^ɕϊ
		 */
		bool getBool( string val ){
			bool ret = false;
			std::transform(val.begin(), val.end(), val.begin(), ::tolower);

			if( val == "on" || val == "true") {
				ret = true;
			}
			return ret;
		}
};

#endif
